# Class RewindableReader

java.lang.Object
java.io.Reader
com.thaiopensource.validate.auto.RewindableReader

All Implemented Interfaces:
  `Rewindable`, `Closeable`, `AutoCloseable`, `Readable`

public class RewindableReader extends Reader implements Rewindable
Rewindable implementation over a reader. Modified from RewindableInputStream by replacing the input stream with a reader.

Author:
  george

- ## Field Summary

  ### Fields inherited from class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RewindableReader(Reader in)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `canRewind()`
  `void`
  `close()`
  `int`
  `read()`
  `int`
  `read(char[] b, int off, int len)`
  `void`
  `rewind()`
  `void`
  `willNotRewind()`

  ### Methods inherited from class java.io.Reader

  `mark, markSupported, nullReader, read, read, ready, reset, skip, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### RewindableReader

    public RewindableReader(Reader in)

- ## Method Details

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `Reader`
    Throws:
      `IOException`

  - ### rewind

    public void rewind()
    Specified by:
      `rewind` in interface `Rewindable`

  - ### canRewind

    public boolean canRewind()
    Specified by:
      `canRewind` in interface `Rewindable`

  - ### willNotRewind

    public void willNotRewind()
    Specified by:
      `willNotRewind` in interface `Rewindable`

  - ### read

    public int read() throws IOException
    Overrides:
      `read` in class `Reader`
    Throws:
      `IOException`

  - ### read

    public int read(char[] b, int off, int len) throws IOException
    Specified by:
      `read` in class `Reader`
    Throws:
      `IOException`